/*
	ȈՉ摜Cu `(draw.c)
*/

#include <stdio.h>
#include <string.h>
#include "image.h"
#include "depend.h"

/*
	fl𓾂()
*/
static inline int point1(Image img, int x, int y)
{
	return (*IMG_POINTER(img, x, y) >> (7 - (x % 8))) & 1;
}
static inline int point8(Image img, int x, int y)
{
	return *IMG_POINTER(img, x, y); 
}
static inline uint32 point16(Image img, int x, int y)
{
	uint16 *p = (uint16 *)IMG_POINTER(img, x, y);

	return RGB2PIX((*p & 0xf800) >> 8, (*p & 0x07e0) >> 3, (*p & 0x001f) << 3);
}
static inline uint32 point24(Image img, int x, int y)
{
	return *(uint32 *)IMG_POINTER(img, x, y) & PIX_MASK;
}
static inline uint32 point32(Image img, int x, int y)
{
	return *(uint32 *)IMG_POINTER(img, x, y);
}

/*
	pixel`()
*/
static inline void pset1(Image img, int x, int y, int pix)
{
	uint8 *p = IMG_POINTER(img, x, y);

	if(pix)
		*p |= (0x80 >> (x % 8));
	else
		*p &= ~(0x80 >> (x % 8));
}
static inline void pset8(Image img, int x, int y, int pix)
{
	*IMG_POINTER(img, x, y) = MINMAX(pix, 0, 0xff);
}
static inline void pset16(Image img, int x, int y, uint32 pix)
{
	*(uint16 *)IMG_POINTER(img, x, y) = ((PIX2B(pix) >> 3) & 0x001f) | (((PIX2G(pix) >> 3) << 6) & 0x07e0) | (((PIX2R(pix) >> 3) << 11) & 0xf800);
}
static inline void pset24(Image img, int x, int y, uint32 pix)
{
	uint32 *p = (uint32 *)IMG_POINTER(img, x, y);

	*p = pix | (*p & ~PIX_MASK);
}
static inline void pset32(Image img, int x, int y, uint32 pix)
{
	*(uint32 *)IMG_POINTER(img, x, y) = pix;
}

/*
	O:
	 pointc - fl𓾂

	:
	 摜img̍W(x, y)̉fl𓾂.

	߂l:
	 fl߂.
*/
uint32 pointc(Image img, int x, int y)
{
	int pix8;

	x = MINMAX(x, 0, img.width - 1);
	y = MINMAX(y, 0, img.height - 1);

	switch(img.bpp) {
	case 32:
		return point32(img, x, y);
	case 24:
		return point24(img, x, y);
	case 16:
		return point16(img, x, y);
	case 8:
		pix8 = point8(img, x, y);
		return YUV2PIX(pix8, 0, 0);
	case 1:
		return (point1(img, x, y) ? PIX_WHITE: PIX_BLACK);
	default:
		return 0;
	}
}

/*
	O:
	 pointg - Px𓾂

	:
	 摜img̍W(x, y)̋Px𓾂.

	߂l:
	 fl߂.
*/
int pointg(Image img, int x, int y)
{
	uint32 pix;

	x = MINMAX(x, 0, img.width - 1);
	y = MINMAX(y, 0, img.height - 1);

	switch(img.bpp) {
	case 32:
		pix = point32(img, x, y);
		return PIX2Y(pix);
	case 24:
		pix = point24(img, x, y);
		return PIX2Y(pix);
	case 16:
		pix = point16(img, x, y);
		return PIX2Y(pix);
	case 8:
		return point8(img, x, y);
	case 1:
		return (point1(img, x, y) ? 0xff: 0);
	default:
		return 0;
	}
}

/*
	O:
	 pointm - 2lf𓾂

	:
	 摜img̍W(x, y)̉f2lf𓾂.

	߂l:
	 2lfl߂.
*/
int pointm(Image img, int x, int y)
{
	uint32 pix;

	x = MINMAX(x, 0, img.width - 1);
	y = MINMAX(y, 0, img.height - 1);

	switch(img.bpp) {
	case 32:
		pix = point32(img, x, y);
		return PIX2Y(pix) > imgParam.mono;
	case 24:
		pix = point24(img, x, y);
		return PIX2Y(pix) > imgParam.mono;
	case 16:
		pix = point16(img, x, y);
		return PIX2Y(pix) > imgParam.mono;
	case 8:
		return point8(img, x, y) > imgParam.mono;
	case 1:
		return point1(img, x, y);
	default:
		return 0;
	}
}

/*
	O:
	 psetc - f`

	:
	 摜img̍W(x, y)ɉflpix̓_`.

	߂l:
	 Ȃ
*/
void psetc(Image img, int x, int y, uint32 pix)
{
	if(IMG_IS_OUTSIDE(img, x, y))
		return;

	switch(img.bpp) {
	case 32:
		pset32(img, x, y, pix);
		break;
	case 24:
		pset24(img, x, y, pix & PIX_MASK);
		break;
	case 16:
		pset16(img, x, y, pix & PIX_MASK);
		break;
	case 8:
		pset8(img, x, y, PIX2Y(pix));
		break;
	case 1:
		pset1(img, x, y, PIX2Y(pix) > imgParam.mono);
		break;
	}
}

/*
	O:
	 psetg - Px`

	:
	 摜img̍W(x, y)ɋPxpix̓_`.

	߂l:
	 Ȃ
*/
void psetg(Image img, int x, int y, int pix)
{
	uint32 px;

	if(IMG_IS_OUTSIDE(img, x, y))
		return;

	switch(img.bpp) {
	case 32:
		/*pset32(img, x, y, YUV2PIX(pix, 0, 0));*/
		px = pointc(img, x, y);
		pset32(img, x, y, yuv2pix(pix, pix2u(px), pix2v(px)));
		break;
	case 24:
		/*pset24(img, x, y, YUV2PIX(pix, 0, 0));*/
		px = pointc(img, x, y);
		pset24(img, x, y, yuv2pix(pix, pix2u(px), pix2v(px)));
		break;
	case 16:
		/*pset16(img, x, y, YUV2PIX(pix, 0, 0));*/
		px = pointc(img, x, y);
		pset16(img, x, y, yuv2pix(pix, pix2u(px), pix2v(px)));
		break;
	case 8:
		pset8(img, x, y, MINMAX(pix, 0, 0xff));
		break;
	case 1:
		pset1(img, x, y, pix > imgParam.mono);
		break;
	}
}

/*
	O:
	 psetm - 2lf`

	:
	 摜img̍W(x, y)2lfpix̓_`.

	߂l:
	 Ȃ
*/
void psetm(Image img, int x, int y, int pix)
{
	if(IMG_IS_OUTSIDE(img, x, y))
		return;

	switch(img.bpp) {
	case 32:
		pset32(img, x, y, pix ? PIX_WHITE: PIX_BLACK);
		break;
	case 24:
		pset24(img, x, y, pix ? PIX_WHITE: PIX_BLACK);
		break;
	case 16:
		pset16(img, x, y, pix ? PIX_WHITE: PIX_BLACK);
		break;
	case 8:
		pset8(img, x, y, pix ? 0xff: 0);
		break;
	case 1:
		pset1(img, x, y, pix);
		break;
	}
}

/*
	O:
	 imgClear - 摜̏

	:
	 摜img

	߂l:
	 Ȃ
*/
void imgClear(Image img, uint32 pix)
{
	int x, y;

	if(pix == PIX_BLACK)
		memset(img.image, 0, img.size);
	else
		for(y = 0; y != img.height; y++)
			for(x = 0; x != img.width; x++)
				psetc(img, x, y, pix);
}

/*
	hԂ
*/
void imgPaint(Image img, int x0, int y0, uint32 pix1, uint32 pix2)
{
	int x, x1, x2, y;

	if(IMG_IS_OUTSIDE(img, x0, y0) || pointc(img, x0, y0) != pix1)
		return;

	for(x = x0; x < img.width && pointc(img, x, y0) == pix1; x++)
		psetc(img, x, y0, pix2);
	x2 = x - 1;
	for(x = x0 - 1; x >= 0 && pointc(img, x, y0) == pix1; x--)
		psetc(img, x, y0, pix2);
	x1 = x + 1;

	for(y = y0 - 1; y <= y0 + 1; y += 2) {
		x = x1;
		do {
			for(; x < x2 && pointc(img, x, y) != pix1; x++)
				;
			imgPaint(img, x, y, pix1, pix2);
			for(; x < x2 && pointc(img, x, y) == pix1; x++)
				;
		} while(x < x2);
	}
}

/* eof */
