/*
	ȈՉ摜Cu {IȕҏW (edit.c)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "image.h"
#include "depend.h"

/*
	O:
	 imgCopy - 摜𕡐

	:
	 摜srcRs[. Rs[ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgCopy(Image *dst, Image src)
{
	if(dst->image == src.image)
		return;

	imgAlloc(dst, src.type, src.width, src.height);
	memcpy(dst->image, src.image, src.size);
}

/*
	O:
	 imgCopyArea, imgCopyAreaR - 摜̈ꕔRs[(͈͂dȂĂ͂ȂȂ)

	:
	 摜src, Jn_(x1, y1), width, height̕, 摜dst(x0, y0)
	ɃRs[. Ɛ̉摜ނقȂƂ̓Rs[ɍ킹ϊ.
	 摜ŃRs[Ƃ͗̈悪dȂĂ͂ȂȂ.

	߂l:
	 Ȃ
*/
void imgCopyArea(Image dst, int x0, int y0, Image src, int x1, int y1, int width, int height)
{
	int i, j, x, y;

	for(y = y0, j = y1; y != y0 + height; y++, j++)
		for(x = x0, i = x1; x != x0 + width; x++, i++)
			psetc(dst, x, y, pointc(src, i, j));
}
void imgCopyAreaR(Image dst, Rect r0, Image src, Rect r1)
{
	imgCopyArea(dst, r0.x, r0.y, src, r1.x, r1.y, r1.width, r1.height);
}

/*
	O:
	 imgMoveArea, imgMoveAreaR - 摜̈ꕔRs[(͈͂dȂĂ悢)

	:
	 imgCopyAreaƓlł邪, ̈悪dȂĂ悢.

	߂l:
	 Ȃ
*/
void imgMoveArea(Image dst, int x0, int y0, Image src, int x1, int y1, int width, int height)
{
	Image tmp = imgNull;

	imgAlloc(&tmp, src.type, width, height);
	imgCopyArea(tmp, 0, 0, src, x1, y1, width, height);
	imgCopyArea(dst, x0, y0, tmp, 0, 0, width, height);
	imgFree(&tmp);
}
void imgMoveAreaR(Image dst, Rect r0, Image src, Rect r1)
{
	imgMoveArea(dst, r0.x, r0.y, src, r1.x, r1.y, r1.width, r1.height);
}

/*
	O:
	 imgAllocCopyArea - 摜̈ꕔRs[, ʂ̉摜𐶐

	:
	 摜src̍W(x, y), width, heightRs[, V摜ւ̃|C
	^dstɑ.

	߂l:
	 Ȃ
*/
void imgAllocCopyArea(Image *dst, Image src, int x, int y, int width, int height)
{
	imgRAlloc(dst, &src, src.type, width, height);
	imgCopyArea(*dst, 0, 0, src, x, y, width, height);
}
void imgAllocCopyAreaR(Image *dst, Image src, Rect r)
{
	imgAllocCopyArea(dst, src, r.x, r.y, r.width, r.height);
}

/*
	O:
	 imgResize - 摜̑傫ύX

	:
	 摜srcwidth, heightɂ. gk͍sȂ. 傫ύX
	ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgResize(Image *dst, Image src, int width, int height)
{
	int x, y;

	if(src.width == width && src.height == height)
		return imgCopy(dst, src);

	imgRAlloc(dst, &src, src.type, width, height);
	for(y = 0; y != height; y++)
		for(x = 0; x != width; x++)
			psetc(*dst, x, y, pointc(src, x, y));
}

/*
	摜gEk()
*/
static void imgZoomSimple(Image *dst, Image src, int width, int height)
{
	int x, y;

	imgRAlloc(dst, &src, src.type, width, height);

	for(y = 0; y != height; y++)
		for(x = 0; x != width; x++)
			psetc(*dst, x, y, pointc(src, x * src.width / width, y * src.height / height));
}

/*
	kpixell߂()
*/
static inline uint32 getPixZoomOut(Image src, int x0, int y0, int width, int height)
{
	int x, y, a = 0, b = 0, c = 0, area;
	uint32 pix;

	area = ((y0 + 1) * src.height / height - y0 * src.height / height) *
	       ((x0 + 1) * src.width  / width - x0 * src.width / width);

	for(y = y0 * src.height / height; y < (y0 + 1) * src.height / height; y++)
		for(x = x0 * src.width / width; x < (x0 + 1) * src.width / width; x++) {
			pix = pointc(src, x, y);
			a += PIX2R(pix);
			b += PIX2G(pix);
			c += PIX2B(pix);
		}
	
	a /= area;
	b /= area;
	c /= area;
	return RGB2PIX(a, b, c);
}

/*
	摜k()
*/
static void imgZoomOut(Image *dst, Image src, int width, int height)
{
	int x, y;

	imgRAlloc(dst, &src, src.type, width, height);
	for(y = 0; y != dst->height; y++)
		for(x = 0; x != dst->width; x++)
			psetc(*dst, x, y, getPixZoomOut(src, x, y, width, height));
}

/*
	摜g傷()
*/
static void imgZoomIn(Image *dst, Image src, int width, int height)
{
	int x, y, x0, y0, dx, dy, i, j, r00, g00, b00, r10, g10, b10, r01, g01, b01, r11, g11, b11, r0, g0, b0, r1, g1, b1, r, g, b;
	uint32 pix;

	imgRAlloc(dst, &src, src.type, width, height);
	for(y0 = 0, y = 0; y0 < dst->height; y0 += dy, y++) {
		dy = (y + 1) * height / src.height - y * height / src.height;
		for(x0 = 0, x = 0; x0 < dst->width; x0 += dx, x++) {
			dx = (x + 1) * width / src.width - x * width / src.width;
			pix = pointc(src, x + 0, y + 0);
			r00 = PIX2R(pix);
			g00 = PIX2G(pix);
			b00 = PIX2B(pix);
			if(y < src.height - 1) {
				pix = pointc(src, x + 0, y + 1);
				r10 = PIX2R(pix);
				g10 = PIX2G(pix);
				b10 = PIX2B(pix);
			} else {
				r10 = r00;
				g10 = g00;
				b10 = b00;
			}
			if(x < src.width - 1) {
				pix = pointc(src, x + 1, y + 0);
				r01 = PIX2R(pix);
				g01 = PIX2G(pix);
				b01 = PIX2B(pix);
			} else {
				r01 = r00;
				g01 = g00;
				b01 = b00;
			}
			if(x < src.width - 1 && y < src.height - 1) {
				pix = pointc(src, x + 1, y + 1);
				r11 = PIX2R(pix);
				g11 = PIX2G(pix);
				b11 = PIX2B(pix);
			} else {
				r11 = r00;
				g11 = g00;
				b11 = b00;
			}
			for(j = y0; j < y0 + dy; j++) {
				r0 = r00 + (r10 - r00) * (j - y0) / dy;
				g0 = g00 + (g10 - g00) * (j - y0) / dy;
				b0 = b00 + (b10 - b00) * (j - y0) / dy;
				r1 = r01 + (r11 - r01) * (j - y0) / dy;
				g1 = g01 + (g11 - g01) * (j - y0) / dy;
				b1 = b01 + (b11 - b01) * (j - y0) / dy;
			
				for(i = x0; i < x0 + dx; i++) {
					r = r0 + (r1 - r0) * (i - x0) / dx;
					g = g0 + (g1 - g0) * (i - x0) / dx;
					b = b0 + (b1 - b0) * (i - x0) / dx;
					psetc(*dst, i, j, RGB2PIX(r, g, b));
				}
			}
		}
	}
}

/*
	摜gEk()
*/
static void imgZoomSmooth(Image *dst, Image src, int width, int height)
{
	if(width >= src.width && height >= src.height)
		imgZoomIn(dst, src, width, height);
	else if(width <= src.width && height <= src.height)
		imgZoomOut(dst, src, width, height);
	else {
		imgZoomSmooth(dst, src, width, src.height * width / src.width);
		imgZoomSmooth(dst, *dst, dst->width, height);
	}
}

/*
	O:
	 imgZoom - 摜gk

	:
	 摜srcwidth, heightƂ. gks. smooth^̂ƂX
	[WOs. gkꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgZoom(Image *dst, Image src, int width, int height, int smooth)
{
	if((width <= 0 && height <= 0) || (src.width == width && src.height == height)) {
		imgCopy(dst, src);
		return;
	}
	if(width <= 0)
		width = src.width * height / src.height;
	if(height <= 0)
		height = src.height * width / src.width;

	if(smooth)
		imgZoomSmooth(dst, src, width, height);
	else
		imgZoomSimple(dst, src, width, height);
}

/*
	O:
	 imgInv - F𔽓]

	:
	 摜src̐F𔽓]. ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgInv(Image *dst, Image src)
{
	int x, y;
	uint32 pix;

	imgRAlloc(dst, &src, src.type, src.width, src.height);

	for(y = 0; y != src.height; y++)
		for(x = 0; x != src.width; x++) {
			pix = pointc(src, x, y);
			psetc(*dst, x, y, RGB2PIX(0xff - PIX2R(pix), 0xff - PIX2G(pix), 0xff - PIX2B(pix)));
		}
}

/*
	O:
	 imgConv - 摜̎ނύX

	:
	 摜src, typeIMG_MONÔƂ2l摜, IMG_GRAŶƂO[XP[,
	IMG_COLOR̂ƂJ[摜ɂ.  typeIMG_MONÔƂ4Ԗڂ̈
	lƂ.
	 ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgConv(Image *dst, Image src, int type, ...)
{
	va_list v;
	int x, y, th;

	switch(type) {
	case IMG_COLOR:
		imgRAlloc(dst, &src, IMG_COLOR, src.width, src.height);
		for(y = 0; y != src.height; y++)
			for(x = 0; x != src.width; x++)
				psetc(*dst, x, y, pointc(src, x, y));
		break;
	case IMG_GRAY:
		imgRAlloc(dst, &src, IMG_GRAY, src.width, src.height);
		for(y = 0; y != src.height; y++)
			for(x = 0; x != src.width; x++)
				psetg(*dst, x, y, pointg(src, x, y));
		break;
	case IMG_MONO:
		va_start(v, type);
		th = va_arg(v, int);
		va_end(v);
		imgRAlloc(dst, &src, IMG_MONO, src.width, src.height);
		for(y = 0; y != src.height; y++)
			for(x = 0; x != src.width; x++)
				psetm(*dst, x, y, pointg(src, x, y) > th);
		break;
	}
}

/*
	O:
	 imgMirror - 摜𔽓]

	:
	 摜src, rl^̂ƂE, ud^̂Ƃ㉺ɔ], dstɐ.
	ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgMirror(Image *dst, Image src, int rl, int ud)
{
	int x, y, i, j;

	imgRAlloc(dst, &src, src.type, src.width, src.height);

	for(y = 0, j = (ud ? src.height - 1: 0); y != src.height; y++, j += (ud ? -1: 1))
		for(x = 0, i = (rl ? src.width - 1: 0); x != src.width; x++, i += (rl ? -1: 1))
			psetc(*dst, x, y, pointc(src, i, j));
}

/*
	O:
	 imgRotate - 摜90xPʂŉ]

	:
	 摜src, 1̂Ƃ90x, 2̂Ƃ180x, 3̂Ƃ270xvɉ].
	ꂽ摜ւ̃|C^dstɑ.

	߂l:
	 Ȃ
*/
void imgRotate(Image *dst, Image src, int rotate)
{
	int x0, y0, x1, y1;

	switch(rotate % 4) {
	case 0:
		imgCopy(dst, src);
		break;
	case 1:
		imgRAlloc(dst, &src, src.type, src.height, src.width);
		for(y0 = 0, x1 = dst->width - 1; y0 != src.height; y0++, x1--)
			for(x0 = 0, y1 = 0; x0 != src.width; x0++, y1++)
				psetc(*dst, x1, y1, pointc(src, x0, y0));
		break;
	case 2:
		imgRAlloc(dst, &src, src.type, src.width, src.height);
		for(y0 = 0, y1 = dst->height - 1; y0 != src.height; y0++, y1--)
			for(x0 = 0, x1 = dst->width - 1; x0 != src.width; x0++, x1--)
				psetc(*dst, x1, y1, pointc(src, x0, y0));
		break;
	case 3:
		imgRAlloc(dst, &src, src.type, src.height, src.width);
		for(y0 = 0, x1 = 0; y0 != src.height; y0++, x1++)
			for(x0 = 0, y1 = dst->height - 1; x0 != src.width; x0++, y1--)
				psetc(*dst, x1, y1, pointc(src, x0, y0));
		break;
	}
}

/*
	Fe[uɒl()
*/
static int setPixtbl(uint32 pix, uint32 *pixtbl, int *npixs, int max_colors)
{
	int h, *p_npixs, *empty_npixs = NULL;
	uint32 *p_pix, *begin, *empty_pix = NULL;

	h = (pix * 3) % max_colors;
	p_pix   = begin = pixtbl + h;
	p_npixs = npixs + h;

	do {
		if(*p_npixs == 0) {
			if(empty_pix == NULL) {
				empty_pix   = p_pix;
				empty_npixs = p_npixs;
			}
		} else {
			if(*p_pix == pix) {
				++*p_npixs;
				return TRUE;
			}
		}

		if(p_pix < pixtbl + max_colors - 1) {
			p_pix++;
			p_npixs++;
		} else {
			p_pix   = pixtbl;
			p_npixs = npixs;
		}
	} while(p_pix != begin);

	if(empty_pix != NULL) {
		*empty_pix   = pix;
		*empty_npixs = 1;
		return TRUE;
	} else
		return FALSE;
}

/*
	O:
	 imgColors - 摜̎gĂF̐pixel߂

	:
	 摜imgɎgĂFzpixtbl, fznpixɑ.
	F̍ő吔max_colorsƂ.

	߂l:
	 gĂF̐߂
*/
int imgColors(Image img, uint32 *pixtbl, int *npixs, int max_colors)
{
	int x, y, n_colors = 0, *p_npixs, *q_npixs;
	uint32 *p_pix, *q_pix;

	memset(npixs, 0, sizeof(int) * max_colors);

	for(y = 0; y != img.height; y++)
		for(x = 0; x != img.width; x++) {
			if(!setPixtbl(pointc(img, x, y), pixtbl, npixs, max_colors))
				goto fail;
		}

	for(p_npixs = npixs, p_pix = pixtbl; p_npixs != npixs + max_colors; p_npixs++, p_pix++)
		if(*p_npixs > 0)
			n_colors++;
		else {
			for(
			q_npixs = npixs + max_colors - 1, q_pix = pixtbl + max_colors - 1;
			q_npixs != p_npixs;
			q_npixs--, q_pix--
			) {
				if(*q_npixs > 0) {
					*p_npixs = *q_npixs;
					*p_pix   = *q_pix;
					*q_npixs = 0;
					n_colors++;
					break;
				}
			}
		}
fail:;
	return n_colors;
}

/*
	imgMaskColor - 摜̓̐F𒊏o
*/
void imgMaskColor(Image *dst, Image src, uint32 pixtbl[], int pixs)
{
	int x, y, i;
	uint32 pix, pix_mask = 0;

	imgRAlloc(dst, &src, src.type, src.width, src.height);

	for(i = 0; i < pixs; i++)
		pix_mask |= pixtbl[i];

	for(y = 0; y != src.height; y++)
		for(x = 0; x != src.width; x++) {
			pix = pointc(src, x, y);
			if(pix & pix_mask)
				for(i = 0; i < pixs; i++)
					if(pix == pixtbl[i]) {
						psetm(*dst, x, y, 1);
						break;
					}
		}
}

/* eof */
