;
; G-KART Q[C
;
.include "gkart.h"

; ő呬x
MAX_SPEED = 111

; rnł̍ő呬x
MIN_SPEED = 16

.area _CODE

;
; Q[C
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL,IX,IY,AF':j
;
game::
	; NA
	ld HL, #0x7f80
	ld DE, #0x7f80 + 1
	ld BC, #68
	ld (HL), #0
	ldir

	; kȂ
	xor A
	call zoom

	; J[g
	ld A, (#lap_start)
	ld (#lap), A
	ld DE, (#kart_pos_start)
	call setpos
	ld A, (#kart_dir_start)
	call setdir
	call rotate
	xor A
	call setv

	; Ԃ
	ld HL, #-300
	ld (#time), HL

	; L[Xg[u(Ȃ)ݒ肷
	xor A
	out (#0x11), A

.if RECORD
	; Oʒu
	ld HL, #end - 2
	ld (#log), HL
	ld (#keycount), A

	; vC?
	ld A, (#replay)
	or A
	jr NZ, log_init_skip

	; Oʒu
	ld HL, #end
	ld (#log), HL
	ld (HL), #0
	inc HL
	ld (HL), #0
log_init_skip:
.endif

game_loop:
	; tCOEyieB?
	ld A, (#penalty)
	or A
	jr Z, game_penalty_last

	; X^[gO?
	ld HL, (#time)
	sla H
	jr C, game_penalty_last

	; 1bo߂?
	ld A, L
	cp #100
	jr C, game_penalty_last

	; tCOEyieB
	xor A
	ld (#penalty), A
game_penalty_last:

.if RECORD
	xor A
	ld (#key456), A
	ld (#keyspc), A

	; vC?
	ld A, (#replay)
	or A
	jr Z, replay_last

	ld HL, #keycount
	ld IY, (#log)

replay_loop:
	; JE^0?
	inc (HL)
	dec (HL)
	jr Z, replay_next

	; L[𓾂
	dec (HL)
	ld A, 0(IY)
	ld (#key456), A
	rrca
	ld (#keyspc), A
	jr replay_last

replay_next:
	; ̃L[𓾂
	inc IY
	inc IY
	ld (#log), IY
	ld A, 1(IY)
	ld (#keycount), A
	ld A, 0(IY)
	cp #0xff
	jp Z, game_end_retire2
	jr replay_loop
replay_last:
.endif

	; 456L[̓͏Ԃ𓾂
.if RECORD
	ld A, (#key456)
	or A
	jr NZ, key456_skip
.endif
	in A, (#0x10)
	ld (#key456), A
key456_skip:

	push AF
	push AF

	; L[Xg[u(SPACEL[)ݒ肷
	push AF
	ld A, #0x08
	out (#0x11), A
	pop AF

	ld IX, #pat_kart_front

	; 4L[Ă邩
	and #0x08
	jr Z, game_key4_skip

	; ~ȂςȂ
	ld HL, #spd
	inc (HL)
	dec (HL)
	jr Z, game_key4_skip

	; 
	ld IX, #pat_kart_left
	call left
	call rotate
game_key4_skip:

	; 6L[Ă邩?
	pop AF
	and #0x20
	jr Z, game_key6_skip

	; ~ȂςȂ
	ld HL, #spd
	inc (HL)
	dec (HL)
	jr Z, game_key6_skip

	; E
	ld IX, #pat_kart_right
	call right
	call rotate
game_key6_skip:

	pop AF

	; ~łȂΑOiEނςȂ
	ld HL, #spd
	inc (HL)
	dec (HL)
	push HL
	jr NZ, game_key5_skip

	; Oiɂ
	ld HL, #back
	ld (HL), #0

	; 5L[Ă邩?
	and #0x10
	jr Z, game_key5_skip

	; ނɂ
	inc (HL)
game_key5_skip:
	pop HL

	; SPACEL[Ă邩?
.if RECORD
	ld A, (#keyspc)
	or A
	jr NZ, keyspc_skip
.endif
	in A, (#0x10)
	ld (#keyspc), A
keyspc_skip:
	and #0x20
	jr Z, game_keyspace_skip

	; S[?
	ld A, (#lap)
	cp #6
	jr Z, game_keyspace_skip

	; tCOEyieB?
	ld A, (#penalty)
	or A
	jr NZ, game_keyspace_skip

	; X^[gO?
	ld A, (#time + 1)
	or A
	jp P, game_keyspace_not_penalty

	; tCOEyieBȂ
	ld (#penalty), A

game_keyspace_not_penalty:
	; Oi?
	ld A, (#back)
	or A
	jr Z, game_keyspace_accel

	; 5L[Ă邩?
	ld A, (#key456)
	and #0x10
	jr Z, game_keyspace_skip

game_keyspace_accel:
	; 
	inc (HL)
	inc (HL)
	inc (HL)
game_keyspace_skip:

	; H̒R
	inc (HL)
	dec (HL)
	jr Z, game_decel_skip
	dec (HL)
	jr Z, game_decel_skip
	dec (HL)
	jr Z, game_decel_skip

	; rn?
	push HL
	call test_rough
	pop HL
	jr NZ, game_decel_skip

	; rn̒R
	ld A, (HL)
	cp #MIN_SPEED
	jr C, game_decel_skip
	dec (HL)
	dec (HL)
	dec (HL)
game_decel_skip:

	; xݒ肷
	ld A, (#back)
	or A
	ld A, (HL)
	jr Z, game_set_speed_forward

game_set_speed_back:
	; ނ
	cp #MIN_SPEED
	jr C, game_set_speed_back_skip
	ld A, #MIN_SPEED
	ld (HL), A
game_set_speed_back_skip:
	neg
	jr game_set_speed

game_set_speed_forward:
	; Oi
	cp #MAX_SPEED
	jr C, game_set_speed
	ld A, #MAX_SPEED
	ld (HL), A
game_set_speed:
	call setv

	; S[?
	ld A, (#lap)
	cp #6
	jp Z, game_end

	; ^CA?
	in A, (#0x1f)
	rlca
	jp C, game_end_retire

	; ԂZ
	ld HL, #time_sub
	ld A, (HL)
	add #25
	ld (HL), A
	ld HL, (#time)
	ld BC, #4
	adc HL, BC
	ld (#time), HL

	; ^CI[o[?
	ld BC, #300
	add HL, BC
	ld BC, #60000 + 300
	or A
	sbc HL, BC
	jp NC, game_end_retire
game_time_last:

	; J[g𓮂
	call move
	ld (#goal), A

	; ǂɏՓ˂?
	call test_wall
	jp Z, game_crush

	; S[ʂ?
	ld A, (#goal)
	or A
	jp NZ, game_goal
game_goal_last:

	; L[Xg[u(456L[)ݒ肷
	ld A, #0x40
	out (#0x11), A

	; Փ˂Ȃʂh炷
	ld HL, #crush
	inc (HL)
	dec (HL)
	jr Z, game_crush_last
	ld A, (HL)
	and #0x02
	ld A, #0x40
	jr Z, game_crush_skip
	ld A, (HL)
	add #0x40
game_crush_skip:
	out (#0x40), A
	dec (HL)
game_crush_last:

	push DE

.if RECORD
	; vC?
	ld A, (#replay)
	or A
	jr NZ, log_last

	; L[̏Ԃ𓾂
	ld A, (#keyspc)
	rlca
	ld HL, #key456
	or (HL)

	; L[̏ԂOƓ?
	ld IY, (#log)
	cp 0(IY)
	jr NZ, log_diff

log_same:
	; L[̏ԂOƓ
	inc 1(IY)

	; JE^I[o[ĂȂ?
	jr NZ, log_last

	; JE^I[o[
	dec 1(IY)

log_diff:
	; L[̏ԂOƈقȂ
	push IY
	pop HL
	or A
	ld BC, (#0x7ffe)
	dec BC
	dec BC
	sbc HL, BC
	jr NC, log_last

	inc IY
	inc IY
	ld 0(IY), A
	ld 1(IY), #1
	ld (#log), IY
log_last:
.endif

	; wi\
	call look

	; }bv\
	push DE
	ld DE, #0x2000
	call putmini
	pop DE

	; ʒu\
	srl D
	srl D
	srl D
	srl D
	ld A, #32
	add D
	ld D, A
	srl E
	srl E
	srl E
	srl E
	call pset

	; Ԃ̕\ʒuɐݒ肷
	ld DE, #0x2874
	call setxy

	; X^[gO?
	ld HL, (#time)
	ld BC, #-300
	push HL
	sbc HL, BC
	pop HL
	jp NC, game_lap_down
game_time_skip:

	; Ԃ\
	call puttime

	; x̕\ʒuɐݒ肷
	ld DE, #0x2074
	call setxy

	; bv^C\邩?
	ld HL, #lap_time_count
	inc (HL)
	dec (HL)
	jp NZ, game_lap_time

	; x\
	ld A, (#spd)
	add #4
	rrca
	rrca
	rrca
	and #0x0f
	ld C, A
	add A
	add A
	add A
	sub C
	ld HL, #pat_speed0
	ld B, #0
	ld C, A
	add HL, BC
	ld BC, #0x0741
	otir
	xor A
	out (#0x41), A

	; bv\
	ld HL, #text_lap
	call putstr
	ld A, (#lap)
	or A
	jr NZ, game_lap_skip
	inc A
game_lap_skip:
	call putchr
game_lap_last:

	; yieB?
	ld A, (#penalty)
	or A
	jr Z, game_skip_penalty

	; "PENALTY"\
	ld DE, #0x2074
	call setxy
	ld HL, #text_penalty
	call putstr
game_skip_penalty:

	pop DE
	jp game_loop

; JnO
game_lap_down:
	; "READY"\
	push HL
	ld HL, #text_ready
	call putstr
	pop HL

	; JEg_E\
	ex DE, HL
	ld HL, #0
	or A
	sbc HL, DE
	call get1sec
	inc A
	call putchr
	jr game_lap_last

; Փ
game_crush:
	; Փ˃JE^ݒ肷
	ld HL, #crush
	ld A, (HL)
	or A
	jr NZ, game_set_crush_skip
	ld A, (#spd)
	srl A
	srl A
	srl A
	ld (HL), A
game_set_crush_skip:

	; ʒu߂
	ld HL, (#old_y16)
	ld (#y16), HL
	ld HL, (#old_x16)
	ld (#x16), HL

	; 
	ld HL, #spd
	ld A, (HL)
	sub #8
	ld (HL), A
	jp P, game_goal_last
	xor A
	ld (HL), A
	jp game_goal_last

; bv^C\
game_lap_time:
	; bv^C\JE^炷
	dec (HL)
	jr Z, _game_lap_last

	; bv^C\
	ld HL, (#lap_time)
	call puttime

	; VL^?
	ld A, (#new_record)
	or A
	jr Z, _game_lap_last

	; "NEWREC!"\
	ld DE, #0x1874
	call setxy
	ld HL, #text_newrec
	call putstr
_game_lap_last:
	jp game_lap_last

; S[ʉ
game_goal:
	; bv𑝂₷, ܂͌炷
	ld HL, #lap
	add (HL)
	ld (HL), A

	; ԂL^邩?
	sub #2
	cp #5
	jp NC, game_goal_last

	; Ԃ̃AhX𓾂
	add A
	add A
	ld C, A
	ld B, #0
	ld IY, #lap1_time
	add IY, BC

	; ԂL^
	ld HL, (#time)
	ld 0(IY), L
	ld 1(IY), H

	; bv^C߂
	ld C, -4(IY)
	ld B, -3(IY)
	or A
	sbc HL, BC
	ld 2(IY), L
	ld 3(IY), H
	ld (#lap_time), HL

	; bv^C\JE^ݒ肷
	ld A, #150 / 4
	ld (#lap_time_count), A
	xor A
	ld (#new_record), A

	; bv^CVL^?
	ld BC, (#top_lap_time)
	or A
	push HL
	sbc HL, BC
	pop HL
	jr NC, _game_goal_last
	jr Z, _game_goal_last

	; bv^CL^
	ld (#top_lap_time), HL
	ld A, #1
	ld (#new_record), A
_game_goal_last:
	jp game_goal_last

; ^CA
game_end_retire:
.if RECORD
	; vC?
	ld A, (#replay)
	or A
	ret NZ

	; O~߂
	ld HL, (#log)
	inc HL
	inc HL
	ld (HL), #0xff
.endif

	; ONL[܂ő҂
	in A, (#0x1f)
	rlca
	jr C, game_end_retire

game_end_retire2:
.if RECORD
	; L[Xg[u(SPACE)ݒ肷
	ld A, #0x08
	out (#0x11), A
.endif

	; Ԃ𖳌ɂ
	ld HL, #0
	ld (#time), HL

	; "RETIRE"\
	ld HL, #text_retire
	jr game_end_skip2

; S[
game_end:
	; bv^C\?
	ld A, (#lap_time_count)
	or A
	jp NZ, game_time_last

	; SPACEL[Ă邩?
game_end_release:
	in A, (#0x10)
	or A
	jp NZ, game_end_release

	; VL^?
	ld HL, (#time)
	ld BC, (#top_time)
	or A
	push HL
	sbc HL, BC
	pop HL
	jr NC, game_end_skip
	jr Z, game_end_skip

	; ԂL^
	ld (#top_time), HL

	; "NEWREC!"\
	ld DE, #0x1874
	call setxy
	ld HL, #text_newrec
	call putstr
game_end_skip:

	; "GOAL"\
	ld HL, #text_goal
game_end_skip2:
	ld DE, #0x2074
	call setxy
	call putstr

	; ʂ\
	xor A
	ld D, A
	ld HL, #lap1_time + 2
	call game_end_putlap
	call game_end_putlap
	call game_end_putlap
	call game_end_putlap
	call game_end_putlap
	call game_end_putlap
	dec D
	ld E, #52
	call setxy
	ld HL, #text_total
	call putstr
	ld A, #0x40
	out (#0x40), A

game_end_press:
	; SPACEL[܂ő҂
	in A, (#0x1f)
	rlca
	ret C
	in A, (#0x10)
	or A
	jr Z, game_end_press

game_end_release2:
	; SPACEL[܂ő҂
	in A, (#0x10)
	or A
	jr NZ, game_end_release2
	ret

game_end_putlap:
	push DE
	push HL

	; Ԃ\
	ld E, #52 + 3 * 8
	call setxy
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	or H
	jr Z, game_end_putlap_retire
	call puttime
game_end_putlap_skip:

	; "LAP:n"\
	ld E, #52
	call setxy
	ld HL, #text_lap
	call putstr
	ld A, D
	srl A
	srl A
	srl A
	inc A
	call putchr

	pop HL
	pop DE

	; ̃bv^C̃AhXƕ\ʒu𓾂
	ld A, D
	add #8
	ld D, A
	inc HL
	inc HL
	inc HL
	inc HL
	ret

game_end_putlap_retire:
	; "--'--''--"\
	ld HL, #text_strike
	call putstr
	jr game_end_putlap_skip

.if RECORD
; vC?
replay::
	.db 0
.endif

.area _DATA

buf::
; bv^C
lap_time:
	.ds 2
lap0_time:
	.ds 4
lap1_time::
	.ds 4
lap2_time::
	.ds 4
lap3_time::
	.ds 4
lap4_time::
	.ds 4
lap5_time::
	.ds 4
lap_time_count:
	.ds 1

; 
time_sub:
	.ds 1
time::
	.ds 2

; VL^?
new_record:
	.ds 1

; tCOEyieB
penalty:
	.ds 1

; bv
lap:
	.ds 1

; 6L[̏
key456:
	.ds 1

; SPACEL[̏
keyspc:
	.ds 1

; ޒ?
back:
	.ds 1

; x
spd:
	.ds 1

; S[ʂ?
goal:
	.ds 1

; Փ˃JE^
crush:
	.ds 1

; L[̓OǍ/ʒu
log:
	.ds 2

; L[JE^
keycount:
	.ds 1

;
; Copyright 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
