;
; G-KART -- 3D Kart Racing Game For SHARP POCKET COMPUTER PC-G850/S/V/VS
;
.include "gkart.h"

MAX_COURSE = 3

.area _CODE

start::
	; ^Cg\
	call cls

	ld BC, #0x500
delay_loop:
	push BC

	ld DE, #0x1022
	call setxy
	ld HL, #text_title
	call putstr

	ld DE, #0x0308
	ld HL, #pat_title
	ld B, #48
	call 0xbfd0

	pop BC
	dec BC
	ld A, B
	or C
	jr NZ, delay_loop

read_circuit:
	; 1/8ɂ
	ld A, #3
	call zoom

	; R[Xf[^WJ
	ld HL, #circuit_no
	ld A, (HL)
	add A
	ld B, #0
	ld C, A
	ld HL, #circuit_table
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	call unpack
	ld (#top_lap_time_address), HL
	ld BC, #4
	ldir

.if RECORD
	xor A
	ld (#replay), A
.endif

loop:
	; ]
	call roll

	; wi\
	ld IX, #pat_space
	ld DE, #0x8080
	call look

	; n}\
	ld DE, #0x2000
	call putmini

	; R[Xԍ\
	xor A
	out (#0x41), A
	ld HL, #text_no
	call putstr
	ld A, (#circuit_no)
	inc A
	call putchr

	; L^(bv^C)\
	ld DE, #0x2064
	call setxy
	ld HL, #text_lap
	call putstr
	ld HL, (#top_lap_time)
	call puttime

	; L^(g[^^C)\
	ld DE, #0x285c
	call setxy
	ld HL, #text_total
	call putstr
	ld A, #CHR_COLON
	call putchr
	ld HL, (#top_time)
	call puttime

	; I?
	in A, (#0x1f)
	rlca
	ret C

	; [ŨR}hs
	call 0xbe53
	cp #0x1e ; SPACEL[
	jr Z, start_game
.if RECORD
	cp #0x05 ; RL[
	jr Z, replay_game
.endif
	ld HL, #circuit_no
	cp #0x34 ; 4L[
	jr Z, prev
	cp #0x36 ; 6L[
	jr Z, next
	jr loop

; ÕR[XI
prev:
	dec (HL)
	jp P, _wait_release_read_circuit
	ld (HL), #MAX_COURSE - 1
	jr _wait_release_read_circuit

; ̃R[XI
next:
	inc (HL)
	ld A, (HL)
	cp #MAX_COURSE
	jr NZ, _wait_release_read_circuit
	ld (HL), #0
_wait_release_read_circuit:
	call wait_release
	jr _read_circuit

.if RECORD
; vC
replay_game:
	ld A, (#selected_circuit_no)
	ld HL, #circuit_no
	cp (HL)
	ld (HL), A
	jr NZ, _read_circuit

	ld A, #1
	ld (#replay), A
.endif

; Q[Jn
start_game:
.if RECORD
	ld A, (#circuit_no)
	ld (#selected_circuit_no), A
.endif

	; Y[C
	ld DE, #0x8080
	ld A, #3
	call zoom_in
	call zoom_in
	call zoom_in
	call zoom_in
	call wait_release

	; Q[C
	call game

	; ʂL^
	ld DE, (#top_lap_time_address)
	ld HL, #top_lap_time
	ld BC, #4
	ldir

	; Y[AEg
	ld DE, #0x8080
	xor A
	call zoom_out
	call zoom_out
	call zoom_out
	call zoom_out
_read_circuit:
	jp read_circuit

;
; L[܂ő҂
;
; 
; Ȃ
;
; o
; AF,B,BC',DE',HL':j
;
wait_release:
wait_release_loop:
	call 0xbe53
	jr C, wait_release_loop
	in A, (#0x1f)
	rlca
	jr C, wait_release_loop
	ret

;
; {ς
;
; 
; A:{
;
; o
; A:A + 1
; BC,HL:j
;
zoom_in:
	call zoom_in_out
	dec A
	ret

;
; {ς
;
; 
; A:{
;
; o
; A:A - 1
; BC,HL:j
;
zoom_out:
	call zoom_in_out
	inc A
	ret

;
; {ς
;
; 
; A:{
;
; o
; A:A - 1
; BC,HL:j
;
zoom_in_out:
	push AF

	call zoom
	ld IX, #pat_space
	call look
	call roll

	pop AF
	ret

;
; ]
;
; 
; Ȃ
;
; o
; AF,HL:j
;
roll:
	ld HL, #r
	ld A, (HL)
	sub #4
	ld (HL), A
	jp rotate

; R[Xԍ
circuit_no:
	.db 0

; L^̃AhX
top_lap_time_address:
	.dw 0

; R[X\
circuit_table:
	.dw circuit1
	.dw circuit2
	.dw circuit3

.if RECORD
; IR[Xԍ
selected_circuit_no:
	.db 0
.endif

;
; Copyright 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
