/*
	ȈՉ摜Cu o(image.c)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "image.h"
#include "depend.h"

const Image imgNull = IMG_NULL;
Imgparam imgParam = {
	128,
	0,
	1,
	"/usr/X11R6/lib/X11/rgb.txt"
};

static Image imgTmp = IMG_NULL;
static int imgError = IMGERR_NONE;

/*
	O:
	 imgIsWrong - 摜s(ĂȂ)ׂ

	:
	 摜sׂ.

	߂l:
	 sȏꍇTRUE, ȏꍇFALSE߂.
*/
int imgIsWrong(Image img)
{
	if(img.type != 0 && img.type != IMG_MONO && img.type != IMG_GRAY && img.type != IMG_COLOR)
		return TRUE;
	if(img.bpp != 0 && img.bpp != 1 && img.bpp != 8 && img.bpp != 16 && img.bpp != 24 && img.bpp != 32)
		return TRUE;
	if(img.size < img.width * img.height * img.bpp / 8)
		return TRUE;
	if(img.size_width < img.width * img.bpp / 8)
		return TRUE;
	return FALSE;
}

/*
	O:
	 imgIsNull - null摜ł邩ׂ

	:
	 摜imgnull摜ł邩ׂ.

	߂l:
	 null摜łȂƂFALSE, null摜łƂFALSEȊO߂.
*/
int imgIsNull(Image img)
{
	return IMG_IS_NULL(img);
}

/*
	O:
	 imgIsOutside - 摜̊Oł邩ׂ

	:
	 W(x,y)摜img̊Oɂ邩ׂ.

	߂l:
	 摜̊OɂƂTRUE, ɂƂFALSE߂.
*/
int imgIsOutside(Image img, int x, int y)
{
	return IMG_IS_OUTSIDE(img, x, y);
}

/*
	O:
	 imgGetError - ŌɔG[𓾂

	:
	 ŌɔG[𒲂ׂ.

	߂l:
	 ŌɔG[߂.
*/
int imgGetError(void)
{
	return imgError;
}

/*
	O:
	 imgGetErrorText - ŌɔG[bZ[W𓾂

	:
	 ŌɔG[bZ[W𓾂

	߂l:
	 ŌɔG[bZ[Wւ̃|C^߂.
*/
const char *imgGetErrorText(void)
{
	const static char *msg[] = {
#if defined(JP)
		"G[Ȃ",
		"Ȃ",
		"sȉ摜",
		"[hłȂ",
		"Z[ułȂ"
		"T|[gĂȂ"
#else
		"No error",
		"No memory",
		"Wrong image",
		"Cannot load image",
		"Cannot save image",
		"Unsupported"
#endif
	};
	static char buf[32];

	if(imgGetError() >= 0 && imgGetError() <= IMGERR_LAST)
		return msg[imgGetError()];
	else {
#if defined(JP)
		sprintf(buf, "[U`G[(%d)", imgGetError());
eles
		sprintf(buf, "User definition error (%d)", imgGetError());
#endif
		return buf;
	}
}

/*
	O:
	 imgSetError - G[R[hݒ肷

	:
	 G[R[hݒ肷

	߂l:
	 Ȃ
*/
void imgSetError(int error_code)
{
	imgError = error_code;
	if(imgParam.exit_when_error && error_code != 0) {
		fprintf(stderr, "%s\n", imgGetErrorText());
		exit(imgGetError());
	}
}

/*
	摜̈̊m/Ċm()
*/
int imgAlloc0(Image *img, int type, int bpp, int width, int height)
{
	if(
	img->image != NULL &&
	img->type       == type                 &&
	img->bpp        == bpp                  &&
	img->width      == width                &&
	img->height     == height               &&
	img->size       == IMG_SIZE(*img)       &&
	img->size_width == IMG_SIZE_WIDTH(*img)
	)
		return TRUE;

	if(imgIsWrong(*img)) {
		imgSetError(IMGERR_WRONG_IMAGE);
		return FALSE;
	}

	img->type       = type;
	img->bpp        = bpp;
	img->width      = width;
	img->height     = height;
	img->size       = IMG_SIZE(*img);
	img->size_width = IMG_SIZE_WIDTH(*img);
	if(img->image == NULL)
		img->image = malloc(img->size + 1);
	else
		img->image = realloc(img->image, img->size + 1);
	if(img->image == NULL) {
		imgSetError(IMGERR_NO_MEMORY);
		return FALSE;
	}

#if defined(USE_X)
	if(img->x != NULL)
		XDestroyImage(img->x);
	img->x = XCreateImage(_display, DefaultVisual(_display, 0), DefaultDepth(_display, 0), ZPixmap, 0, img->image, width, height, BitmapPad(_display), 0);
#endif

	return TRUE;
}

/*
	O:
	 imgFree - 摜̈

	:
	 |C^imĝ߂摜, null摜Ƃ.

	߂l:
	 Ȃ
*/
void imgFree(Image *img)
{
#ifdef USE_X
	if(img->x != NULL) {
		XDestroyImage(img->x);
		img->image = NULL;
	}
#endif
	if(img->image != NULL)
		free(img->image);

	*img = imgNull;
}

/*
	O:
	 imgAlloc - 摜𐶐

	:
	 摜̎type(IMG_COLOR̂ƂJ[, IMG_GRAŶƂO[XP[,
	IMG_MONÔƂ2l摜),  width,  height ̉摜𐶐.
	 ꂽ摜ւ̃|C^imgɑ.

	߂l:
	 摜𐶐łƂTRUE, oȂƂFALSE߂.
*/
int imgAlloc(Image *img, int type, int width, int height)
{
	int success;

	if(type == IMG_COLOR)
		success = imgAlloc0(img, type, 24, width, height);
	else if(type == IMG_GRAY)
		success = imgAlloc0(img, type, 8, width, height);
	else if(type == IMG_MONO)
		success = imgAlloc0(img, type, 1, width, height);
	else {
		imgSetError(IMGERR_WRONG_IMAGE);
		return FALSE;
	}
	imgClear(*img, PIX_BLACK);

	return success;
}

/*
	O:
	 imgRAlloc - Sourcedestinationłꍇ͕, 摜̈mۂ

	:
	 |C^dstƃ|C^srcłȂꍇ, imgSetƓl̓. dst
	srcłꍇ, 摜*srctemporarÿɃRs[, srctemporarÿ
	̃|C^Ƃ, dstɉ摜̈𐶐.
	 ̊֐͒ʏ, ֐ꍇɎgp.

	߂l:
	 摜𐶐łƂTRUE, oȂƂFALSE߂.
*/
int imgRAlloc(Image *dst, Image *src, int type, int width, int height)
{
	if(imgIsWrong(*src)) {
		imgSetError(IMGERR_WRONG_IMAGE);
		return FALSE;
	}
	if(!imgIsNull(*dst) && dst->image == src->image) {
		imgCopy(&imgTmp, *src);
		*src = imgTmp;
	}

	return imgAlloc(dst, type, width, height);
}

/*
	O:
	 imgFreeTmp - temporarÿ

	:
	 temporarÿJ. ̊֐, ʏgpKv͂Ȃ.

	߂l:
	 Ȃ
*/
void imgFreeTmp(void)
{
	imgFree(&imgTmp);
}

/*
	O:
	 imgLoad - 摜fBXNǂݍ

	:
	 t@Cfilẻ摜ǂݍ, |C^imgɉ摜𐶐. [hł
	摜MicrosoftBitmap񈳏k`, PortablePixMap/GrayMap/BitMap eLXg/
	oCi`)ł.

	߂l:
	 ǂݍ݂ɐƂTRUE, sƂFALSE߂.
*/
int imgLoad(Image *img, const char *file)
{
	if(ppmLoad(img, file))
		return TRUE;
	else if(dibLoad(img, file))
		return TRUE;

	imgSetError(IMGERR_CANNOT_LOAD);
	return FALSE;
}

/*
	O:
	 imgLoadConv - 摜fBXNǂݍŕϊ

	:
	 t@Cfilẻ摜, type(IMG_COLOR, IMG_GRAY, IMG_MONO), width, heightɕϊ
	, |C^imgɐ. type, width, height0ƂƂ̗͂vfϊ
	Ȃ.

	߂l:
	 ǂݍ݂ɐƂTRUE, sƂFALSE߂.
*/
int imgLoadConv(Image *img, const char *file, int type, int width, int height)
{
	if(!imgLoad(img, file))
		return FALSE;

	if(width > 0 && height <= 0)
		height = img->height * width / img->width;
	else if(width <= 0 && height > 0)
		width = img->width * height / img->height;

	if(type != 0)
		imgConv(img, *img, type, imgParam.mono);
	if(width > 0 && height > 0)
		imgZoom(img, *img, width, height, imgParam.smooth);
	return TRUE;
}

/*
	O:
	 imgSave - 摜fBXNɏ

	:
	 摜img  `format(IMG_PXMBIN̂ƂPortablePixMap/GrayMap/PixMapoCi`
	, IMG_PXMTXT̂ƂeLXg`, IMG_BITMAP̂ƂMicrosoftBitmap̌`), t@C
	file ŃfBXNɏ.

	߂l:
	 ݂ƂTRUE, sƂFALSE߂.
*/
int imgSave(Image img, const char *file, int format)
{
	int chk;

	if(IMG_IS_NULL(img))
		return FALSE;

	switch(format) {
	case IMG_PXMBIN:
		chk = ppmbinSave(img, file);
		break;
	case IMG_PXMTXT:
		chk = ppmtxtSave(img, file);
		break;
	case IMG_BITMAP:
		chk = dibSave(img, file);
		break;
	default:
		chk = FALSE;
		break;
	}

	if(!chk)
		imgSetError(IMGERR_CANNOT_SAVE);
	return chk;
}

/*
	O:
	 imgSaveSuf - 摜fBXNɏ(gqɂČ`ς)

	:
	 摜imgt@CfileŃfBXNɏ. t@C̊gq
	.ppm/.pgm/.pbm̂Ƃ PortablePixMap/GrayMap/BitMapoCi`, .bmp̂
	 MicrosoftBitmap`ŕۑ. ȊÔƂ͌`formatŕۑ.

	߂l:
	 ݂ƂTRUE, sƂFALSE߂.
*/
int imgSaveSuf(Image img, const char *file, int format)
{
	const char *p;

	p = file + strlen(file) - 4;

	if(!strcasecmp(p, ".ppm") || !strcasecmp(p, ".pgm") || !strcasecmp(p, ".pbm"))
		return imgSave(img, file, IMG_PXMBIN);
	else if(!strcasecmp(p, ".bmp"))
		return imgSave(img, file, IMG_BITMAP);
	else
		return imgSave(img, file, format);
}

/*
	摜̕\
*/
void imgInfo(FILE *fp, Image img)
{
	if(imgIsWrong(img))
		fprintf(fp, "Wrong image\n");
	fprintf(
	fp,
	"      type = %s%s%s%s%s(%x)\n",
	img.type == 0 ? "null": "",
	img.type == IMG_COLOR ? "IMG_COLOR": "",
	img.type == IMG_GRAY ? "MG_GRAY": "",
	img.type == IMG_MONO ? "IMG_MONO": "",
	img.type != IMG_COLOR && img.type != IMG_GRAY && img.type != IMG_MONO && img.type != 0 ? "unknown": "",
	img.type
	);
	fprintf(fp, "       bpp = %d\n", img.bpp);
	fprintf(fp, "     width = %d\n", img.width);
	fprintf(fp, "    height = %d\n", img.height);
	fprintf(fp, "      size = %d\n", img.size);
	fprintf(fp, "size_width = %d\n", img.size_width);
	fprintf(fp, "     image = %p\n", img.image);
#ifdef USE_X
	fprintf(fp, "         x = %p\n", img.x);
#endif
}

/* eof */
