/*
	]e[u, sine[u̍쐬
*/

#include <stdio.h>
#include <math.h>

#define CENTER_Y	16.0
#define CAMERA_X	11.5
#define CAMERA_Y	8.0
#define CAMERA_Z	3.0
#define SCREEN_Z	0.5

double dist(double y)
{
	return CAMERA_Y * (CAMERA_Z + SCREEN_Z + 24.0) / (CAMERA_Z + y) - CAMERA_Y;
}

void conv(double *a, double *b, double x, double y)
{
	*b = dist(y) - dist(CENTER_Y);
	*a = ((x - CAMERA_X) * (CAMERA_Y + dist(y)) / CAMERA_Y) / 2.0;
}

int main(int argc, char *argv[])
{
	int i, j, x, y, n;
	double a, b, c, d, r;

	for(j = 0; j < 8; j++) {
		r = (double )j * 2.0 * M_PI / 32.0;

		printf("conv_table%d::\n", j);

		n = 0;
		for(i = 0; i < 24; i += 4) {
			for(x = 0; x < 24; x++) {
				for(y = i; y < i + 4; y++) {
					conv(&a, &b, (double )x, (double )y);
					c = a * cos(r) + b * sin(r);
					d = -a * sin(r) + b * cos(r);

					printf("\t.dw 0x%02x%02x ; %d: %dx (%d,%d)(%d,%d)\n",
					(unsigned char )rint(c),
					(unsigned char )rint(d),
					n++,
					j * 90 / 8,
					x,
					y,
					(int )rint(d),
					(int )rint(c));
				}
			}
		}

		printf("\n");
	}

	printf("sin_table::\n");

	for(i = 0; i <= 64; i++) {
		r = (double )i * 360.0 / 256.0;

		printf("\t.db %d ; sin(%d)\n", (int )rint(sin(r * M_PI / 180.0) * 128.0), (int )rint(r));
	}

	return 0;
}

/* eof */
