/*
	ȈՉ摜Cu ppm/pgm/pbmC[W(ppm.c)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "image.h"
#include "depend.h"

#define BUF_SIZE	4096	/* obt@TCY */
#define IS_SEP(x)	((x) == ' ' || (x) == '\t' || (x) == '\n' || (x) == '\r')	/* Zp[^ł邩 */
#define MAGIC(type, istxt)	((type == IMG_MONO ? 1: (type == IMG_GRAY ? 2: 3)) + (istxt ? 0: 3) + '0')	/* magic number 쐬 */

/*
	magic number ppm/pgm/pbm`ł邩ׂ
*/
inline static int ispxm(const char *magic)
{
	if(magic[0] != 'P' || magic[1] < '1' || magic[1] > '6')
		return TRUE;

	return FALSE;
}

/*
	magic number  J[, O[XP[, 2l摜̂ł邩ׂ
*/
inline static int getType(const char *magic)
{
	if(magic[1] == '1' || magic[1] == '4')
		return IMG_MONO;
	else if(magic[1] == '2' || magic[1] == '5')
		return IMG_GRAY;
	else
		return IMG_COLOR;
}

/*
	magic number eLXg`ł邩ׂ
*/
inline static int istext(const char *magic)
{
	return magic[1] == '1' || magic[1] == '2' || magic[1] == '3';
}

/*
	Zp[^ǂݍ
*/
inline static void readSep(int fd, char *buf, int size, char **p)
{
	int comment = FALSE;

	while(IS_SEP(**p) || comment) {
		++*p;

		if(*p == buf + size) {
			read(fd, buf, size);
			*p = buf;
		}
		if(**p == '#')
			comment = TRUE;
		else if(**p == '\n' || **p == '\r')
			comment = FALSE;
	}
}

/*
	ǂݍ
*/
inline static int readVal(int fd, char *buf, int size, char **p)
{
	char value[8], *q = value;

	do {
		*q++ = *(*p)++;

		if(*p == buf + size) {
			read(fd, buf, size);
			*p = buf;
		}
	} while(isdigit(**p));
	*q = '\0';

	return atoi(value);
}

/*
	ǂ
*/
inline static int getVal(int fd, char *buf, int size, char **p)
{
	int x;

	x = readVal(fd, buf, size, p);
	readSep(fd, buf, size, p);

	return x;
}

/*
	ŏ̐ǂ
*/
inline static int getValFirst(int fd, char *buf, int size, char **p)
{
	read(fd, buf, size);
	*p = buf;
	readSep(fd, buf, size, p);

	return readVal(fd, buf, size, p);
}

/*
	ppm/pgm/pbm`̃[h
*/
int ppmLoad(Image *img, const char *file)
{
	int fd, x, y, type, width, height, r, g, b, pix, size_image;
	char magic[2], buf[BUF_SIZE], *p;
	uint8 *buf_image, *s, *t;

	if((fd = open(file, O_RDONLY | O_BINARY)) == -1)
		return FALSE;

	/* magic number ǂݍ */
	read(fd, magic, 2);
	if(ispxm(magic)) {
		close(fd);
		return FALSE;
	}
	type = getType(magic);

	/* header ǂݍ */
	width  = getValFirst(fd, buf, BUF_SIZE, &p);
	height = getVal(fd, buf, BUF_SIZE, &p);
	if(type != IMG_MONO)
		getVal(fd, buf, BUF_SIZE, &p);


	/* image ǂݍ */
	imgAlloc(img, type, width, height);
	if(istext(magic)) {
		switch(type) {
		case IMG_COLOR:
			for(y = 0; y != img->height; y++)
				for(x = 0; x != img->width; x++) {
					r = getVal(fd, buf, BUF_SIZE, &p);
					g = getVal(fd, buf, BUF_SIZE, &p);
					b = getVal(fd, buf, BUF_SIZE, &p);
					psetc(*img, x, y, rgb2pix(r, g, b));
				}
			break;
		case IMG_GRAY:
			for(y = 0; y != img->height; y++)
				for(x = 0; x != img->width; x++)
					psetg(*img, x, y, getVal(fd, buf, BUF_SIZE, &p));
			break;
		case IMG_MONO:
			for(y = 0; y != img->height; y++)
				for(x = 0; x < img->width; x += 8) {
					pix = getVal(fd, buf, BUF_SIZE, &p);
					psetm(*img, x + 0, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 1, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 2, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 3, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 4, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 5, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 6, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
					psetm(*img, x + 7, y, getVal(fd, buf, BUF_SIZE, &p) ^ 1);
				}
			break;
		}
	} else {
		/*  t@ČɃS~ȂƂ肵Ă */
		switch(type) {
		case IMG_COLOR:
			size_image = 3 * height * width;
			break;
		case IMG_GRAY:
			size_image = height * width;
			break;
		case IMG_MONO:
		default:
			size_image = height * (width + 7) / 8;
			break;
		}

		lseek(fd, -size_image, SEEK_END);
		switch(type) {
		case IMG_COLOR:
#ifdef IMAGE_BGR
			buf_image = malloc(size_image);
			read(fd, buf_image, size_image);
			for(s = IMG_POINTER(*img, 0, 0), t = buf_image; s != IMG_POINTER(*img, 0, 0) + img->size; s += 3, t += 3) {
				s[0] = t[2];
				s[1] = t[1];
				s[2] = t[0];
			}
			free(buf_image);
#else
			read(fd, img->image, size_image);
#endif
			break;
		case IMG_GRAY:
			read(fd, img->image, size_image);
			break;
		case IMG_MONO:
			buf_image = malloc(size_image);
			read(fd, buf_image, size_image);
			for(s = IMG_POINTER(*img, 0, 0), t = buf_image; s != IMG_POINTER(*img, 0, 0) + img->size; s++, t++)
				*s = *t ^ 0xff;
			free(buf_image);
			break;
		}
	}

	close(fd);
	return TRUE;
}

/*
	wb_
*/
static void writeHeader(int fd, Image img, int istxt)
{
	char buf[16];

	sprintf(buf, "P%c\n%d %d\n", MAGIC(img.type, istxt), img.width, img.height);
	write(fd, buf, strlen(buf));
	if(img.type != IMG_MONO) {
		sprintf(buf, "%d\n", 255);
		write(fd, buf, strlen(buf));
	}
}

/*
	ppm/pgm/pbmeLXg`ŕۑ
*/
int ppmtxtSave(Image img, const char *file)
{
	uint32 pix;
	int fd, n = 0, x, y;
	char buf[80];

	if((fd = open(file, O_CREAT | O_TRUNC | O_RDWR | O_BINARY, 0664)) == -1)
		return FALSE;

	/* wb_ */
	writeHeader(fd, img, TRUE);

	/* image */
	for(y = 0; y != img.height; y++)
		for(x = 0; x != img.width; x++) {
			switch(img.bpp) {
			case 32:
			case 24:
			case 16:
				pix = pointc(img, x, y);
				sprintf(buf, "%s %d %d %d", buf, pix2r(pix), pix2g(pix), pix2b(pix));
				n += 3;
				break;
			case 8:
				pix = pointg(img, x, y);
				sprintf(buf, "%s %d", buf, pix);
				n++;
				break;
			case 1:
			default:
				pix = pointm(img, x, y);
				sprintf(buf, "%s %d", buf, pix ^ 1);
				n++;
			}

			if(n >= 16 || x == img.width - 1) {
				sprintf(buf, "%s\n", buf);
				write(fd, buf, strlen(buf));
				strcpy(buf, "");
				n = 0;
			}
		}

	close(fd);

	return TRUE;
}

/*
	ppm/pgm/pbmoCi`ŕۑ
*/
int ppmbinSave(Image img, const char *file)
{
	int fd, x, y;
	uint32 pix;
	uint8 *buf, *p, *q;

	if((fd = open(file, O_CREAT | O_TRUNC | O_RDWR | O_BINARY, 0664)) == -1)
		return FALSE;

	/* wb_ */
	writeHeader(fd, img, FALSE);

	/* image */
	switch(img.bpp) {
		case 24:
#ifndef IMAGE_BGR
			write(fd, img.image, img.size);
			break;
#endif
		case 32:
		case 16:
			p = buf = malloc(img.width * img.height * 3);
			for(y = 0; y != img.height; y++)
				for(x = 0; x != img.width; x++) {
					pix = pointc(img, x, y);
					p[0] = pix2r(pix);
					p[1] = pix2g(pix);
					p[2] = pix2b(pix);
					p += 3;
				}
			write(fd, buf, img.width * img.height * 3);
			free(buf);
			break;
		case 8:
			write(fd, img.image, img.size);
			break;
		case 1:
			buf = malloc(img.size);
			for(p = buf, q = img.image; p < img.image + img.size; p++, q++)
				*p = *q ^ 0xff;
			write(fd, buf, img.size);
			free(buf);
			break;
	}

	close(fd);
	return TRUE;
}

/* eof */
